<%@ page import="java.util.Collection,
                 java.io.IOException,
                 java.util.Iterator,
                 org.jboss.jrunit.data.Benchmark,
                 java.sql.Connection,
                 org.jboss.jrunit.webinterface.database.ConnectionFactory,
                 org.jboss.jrunit.controller.persistence.BenchmarkDatabaseBenchmarkPersistence,
                 org.jboss.jrunit.data.BenchmarkExecution,
                 org.jboss.jrunit.table.XrefsTableList,
                 org.jboss.jrunit.table.AxisReference"%>

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<%!
    void printItems(JspWriter out, int parentId) throws Exception
    {
        Connection conn = ConnectionFactory.createConnection();
        BenchmarkDatabaseBenchmarkPersistence persistence = new BenchmarkDatabaseBenchmarkPersistence(conn);

        Collection coll = persistence.readBenchmarks(parentId,true);
        XrefsTableList list = new XrefsTableList(2);
        out.println("<img src='./chart.servlet?benchmarkId=" + parentId + "' width='100%'>");
        addItems(list,coll);
        list.doOrdering();
        printItems(out,list,0);
        conn.close();
    }

    private void addItems(XrefsTableList list, Collection collection) throws IOException
    {
        if (collection==null) return;
        Iterator iter = collection.iterator();

        while (iter.hasNext())
        {
            Benchmark benchmark = (Benchmark) iter.next();
            BenchmarkExecution executions[] = benchmark.getExecution();
            for (int i=0;i<executions.length;i++)
            {
                AxisReference row = new AxisReference(new Comparable[]{benchmark.getName()});
                AxisReference column = new AxisReference(new Comparable[]{executions[i].getExecutionDate()});
                list.addElement(new AxisReference[]{row,column},executions[i].getElapsedTime()/executions[i].getExecutions());
            }
            addItems(list,benchmark.getSubBenchmarks().values());
        }
    }
    private void printItems(JspWriter out, XrefsTableList list, int size) throws IOException
    {

        AxisReference referenceRow = (AxisReference) list.getAxisSet()[0].first();
        AxisReference referenceColumn = (AxisReference) list.getAxisSet()[1].first();

        out.println("<table>");

        Iterator iter = list.getAxisSet()[1].iterator();
        StringBuffer[] lines = new StringBuffer[referenceColumn.getReferences().length];
        for (int i=0;i<lines.length;i++)
        {
            lines[i]=new StringBuffer();
            if (referenceRow.getReferences().length>0)
            {
                lines[i].append("<tr><td colspan='"+referenceRow.getReferences().length + "'>&nbsp</td>");
            }
        }

        while (iter.hasNext())
        {
            AxisReference itemReference = (AxisReference)iter.next();
            Comparable[] references = itemReference.getReferences();
            for (int i=0;i<lines.length;i++)
            {
                lines[i].append("<td>" + references[i] + "</td>");
            }
        }
        
        for (int i=0;i<lines.length;i++)
        {
            lines[i].append("</tr>");
            out.println(lines[i]);
        }

        iter = list.getContentSet().iterator();

        int lastrow=-1;
        int lastcol=-1;

        while (iter.hasNext())
        {
            XrefsTableList.ValueContainer valueContainer = (XrefsTableList.ValueContainer)iter.next();

            int currentrow=valueContainer.getAxis(0).getOrder();

            if (lastrow!=currentrow)
            {
                lastcol=-1;
                if (lastrow!=-1)
                {
                    out.println("</tr>");
                }
                lastrow=currentrow;
                out.println("<tr>");
                referenceRow = valueContainer.getAxis(0);
                
                for (int i=0;i<referenceRow.getReferences().length;i++)
                {
                    out.println("<td>" + referenceRow.getReferences()[i] + "</td>");
                }
            }

            int currentcolumn = valueContainer.getAxis(1).getOrder();
            for (int i=lastcol+1;i<currentcolumn;i++)
            {
                System.out.println("column " + i);
                out.println("<td>&nbsp;</td>");
            }
            lastcol=currentcolumn;

            out.println("<td>"+valueContainer.getValue() + "</td>");
        }

        out.println("</tr></table>");
    }
%>

<% int parentId = 0;
   try
   {
       parentId=Integer.parseInt(request.getParameter("benchmarkId"));
   }
   catch (Exception ignored){}%>

<html>
<%
    printItems(out,parentId);
%>
</html>